Imports System
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Reflection
Imports System.Text
Imports System.Reflection.Pointer
Imports System.Management

Public Class eSSlRFID

    Private Function GetComInfo() As String
        Dim ret As String = ""
        Try
            Dim searcher As New ManagementObjectSearcher("root\CIMV2", "SELECT * FROM Win32_SerialPort")

            For Each queryObj As ManagementObject In searcher.[Get]()
                If queryObj("PNPDeviceID").ToString().Contains("USB") Then
                    ret = queryObj("DeviceID").ToString()
                    ret = ret(ret.Length - 1)
                    Exit For
                Else
                    Console.WriteLine("NotFound")
                End If
            Next
        Catch e As ManagementException
            MessageBox.Show("An error occurred while querying for WMI data: " + e.Message)
        End Try
        Return ret
    End Function

    Private Sub DevStatusPrint(ByVal status As Byte)
        Select Case status
            Case DevStatus.BAD_COMMAND
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: BAD_COMMAND"
                Exit Select
            Case DevStatus.BAD_PARAM
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: BAD_PARAM"
                Exit Select
            Case DevStatus.COMM_ERR
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: COMM_ERR"
                Exit Select
            Case DevStatus.COMM_OK
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: SUCCESS"
                Exit Select
            Case DevStatus.ERROR_OUT_SECTOR
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: ERROR_OUT_SECTOR"
                Exit Select
            Case DevStatus.NO_CARD
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: NO_CARD"
                Exit Select
            Case DevStatus.PARAM_OK
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: PARAM_OK"
                Exit Select
            Case DevStatus.PASS_FAILED
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: AUTHENTICATION FAILURE"
                Exit Select
            Case DevStatus.RECEIVE_ERROR
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: RECEIVE_ERROR"
                Exit Select
            Case DevStatus.SET_FAILED
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: SET_FAILED"
                Exit Select
            Case DevStatus.TIME_OUT
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: TIME_OUT"
                Exit Select
            Case DevStatus.UNKNOWN_ERROR
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: UNKNOWN_ERROR"
                Exit Select
            Case Else
                OPTextBox.Text = OPTextBox.Text & vbNewLine & "device status: SECTOR CORRUPTED"
                Exit Select
        End Select

    End Sub

    Private Sub pb_Read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Read.Click

        Try
            If Not GetComInfo() = "" Then
                Dim ret As Integer = serialportInit(CInt(GetComInfo()))

                Dim blockData As Byte() = New Byte(63) {}
                'Dim key As Byte() = New Byte(5) {&HFF, &HFF, &HFF, &HFF, &HFF, &HFF}
                Dim key As Byte() = New Byte(5) {}
                Dim keyStr As String = CB_ReadKey.SelectedItem.ToString
                keyStr = keyStr.Replace(" ", "")
                Dim i As Integer = 0
                While (keyStr.Length > 0)
                    key(i) = System.Convert.ToByte(keyStr.Substring(0, 2), 16)
                    keyStr = keyStr.Substring(2, keyStr.Length - 2)
                    i += 1
                End While

                Dim addrB As Byte = System.Convert.ToByte(CB_Read1.Text, 10)
                Dim block As Byte = System.Convert.ToByte(CB_Read2.Text, 10)
                Dim len As UShort = 64
                Dim status As Byte
                Dim uid As Byte() = New Byte(3) {}

                Dim blockDataPtr As IntPtr = Marshal.AllocHGlobal(blockData.Length)
                Dim keyPtr As IntPtr = Marshal.AllocHGlobal(key.Length)
                Dim statusPtr As IntPtr = Marshal.AllocHGlobal(1)
                Dim uidPtr As IntPtr = Marshal.AllocHGlobal(4)
                Marshal.Copy(key, 0, keyPtr, key.Length)

                ret = MifareReadBlockData(addrB, block, blockDataPtr, len, keyPtr, uidPtr, statusPtr)
                status = Marshal.ReadByte(statusPtr)

                If Not ret = -1 Then
                    Marshal.Copy(blockDataPtr, blockData, 0, ret)
                    Marshal.Copy(uidPtr, uid, 0, 4)

                    'Dim uidInt As Int32 = Marshal.ReadInt32(uidPtr)

                    Dim blockDatastr As String = ""
                    For i = 0 To ret - 1
                        Dim temp As String = blockData(i).ToString("X")
                        If (temp.Length = 1) Then
                            temp = "0" & temp
                        End If
                        blockDatastr = blockDatastr & temp & " "
                    Next
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & " recieved data:"
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & blockDatastr

                    blockDatastr = ""
                    For i = 0 To 3
                        Dim temp As String = uid(i).ToString("X")
                        If (temp.Length = 1) Then
                            temp = "0" & temp
                        End If
                        blockDatastr = blockDatastr & temp & " "
                    Next
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & "From card no: " & blockDatastr
                    blockDatastr = ""
                Else
                    'OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Data not found"
                End If
                DevStatusPrint(status)
                Marshal.FreeHGlobal(blockDataPtr)
                Marshal.FreeHGlobal(keyPtr)
                Marshal.FreeHGlobal(statusPtr)
                Marshal.FreeHGlobal(uidPtr)
                MifareFree()
            Else
                OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Reader not found"
            End If
        Catch ex As Exception
            OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ex.Message
            MifareFree()
        End Try
    End Sub

    Private Sub pb_Write_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_Write.Click
        Try
            If Not GetComInfo() = "" Then
                Dim ret As Integer = serialportInit(CInt(GetComInfo()))

                ''''''Key Operations''''''
                Dim key As Byte() = New Byte(5) {}
                Dim keyStr As String = CB_WriteKey.SelectedItem.ToString
                keyStr = keyStr.Replace(" ", "")
                Dim i As Integer = 0
                While (keyStr.Length > 0)
                    key(i) = System.Convert.ToByte(keyStr.Substring(0, 2), 16)
                    keyStr = keyStr.Substring(2, keyStr.Length - 2)
                    i += 1
                End While
                ''''''Card Write Operations''''''
                keyStr = TxtBox_Write.Text.Replace(" ", "")
                If keyStr.Length Mod 2 = 0 Then
                    Dim writeData As Byte() = New Byte((CB_Write2.SelectedIndex + 1) * 16 - 1) {}
                    If keyStr.Length > (writeData.Length * 2) Then
                        keyStr = keyStr.Remove(writeData.Length * 2)
                    End If
                    i = 0
                    While (keyStr.Length > 0)
                        writeData(i) = System.Convert.ToByte(keyStr.Substring(0, 2), 16)
                        keyStr = keyStr.Substring(2, keyStr.Length - 2)
                        i += 1
                    End While
                    Dim addrB As Byte = System.Convert.ToByte(CB_Write1.SelectedItem, 10)
                    Dim block As Byte = System.Convert.ToByte(CB_Write2.SelectedItem, 10)
                    Dim len As UShort = 64
                    Dim status As Byte
                    Dim uid As Byte() = New Byte(3) {}

                    Dim writeDataPtr As IntPtr = Marshal.AllocHGlobal(writeData.Length)
                    Dim keyPtr As IntPtr = Marshal.AllocHGlobal(key.Length)
                    Dim statusPtr As IntPtr = Marshal.AllocHGlobal(1)
                    Dim uidPtr As IntPtr = Marshal.AllocHGlobal(4)
                    Marshal.Copy(key, 0, keyPtr, key.Length)
                    Marshal.Copy(writeData, 0, writeDataPtr, writeData.Length)

                    ret = MifareWriteBlockData(addrB, block, writeDataPtr, len, keyPtr, uidPtr, statusPtr)
                    status = Marshal.ReadByte(statusPtr)
                    If Not ret = -1 Then
                        Marshal.Copy(uidPtr, uid, 0, 4)

                        'Dim uidInt As Int32 = Marshal.ReadInt32(uidPtr)

                        Dim writeDatastr As String = ""

                        For i = 0 To 3
                            Dim temp As String = uid(i).ToString("X")
                            If (temp.Length = 1) Then
                                temp = "0" & temp
                            End If
                            writeDatastr = writeDatastr & temp & " "
                        Next
                        OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString()
                        OPTextBox.Text = OPTextBox.Text & vbNewLine & "To card no: " & writeDatastr
                    Else

                    End If
                    DevStatusPrint(status)

                    Marshal.FreeHGlobal(writeDataPtr)
                    Marshal.FreeHGlobal(keyPtr)
                    Marshal.FreeHGlobal(statusPtr)
                    Marshal.FreeHGlobal(uidPtr)
                Else
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & "Invalid Write Data"
                End If

                MifareFree()
            Else
                OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Reader not found"
            End If
        Catch ex As Exception
            OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ex.Message
            MifareFree()
        End Try

    End Sub

    Private Sub pb_CardNumber_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_CardNumber.Click
        Try
            If Not GetComInfo() = "" Then
                Dim ret As Boolean = False
                Dim addr As Byte() = New Byte(3) {}
                Dim addrPtr As IntPtr = Marshal.AllocHGlobal(addr.Length)

                Dim retI As Integer = serialportInit(CInt(GetComInfo()))
                ret = MifareCheckCard(addrPtr)
                If (ret) Then
                    Marshal.Copy(addrPtr, addr, 0, 4)

                    Dim addrstr As String = ""
                    For i As Integer = 0 To 3
                        Dim temp As String = addr(i).ToString("X")
                        If (temp.Length = 1) Then
                            temp = "0" & temp
                        End If
                        addrstr = addrstr & temp & " "
                    Next
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & " recieved data:"
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & addrstr
                Else
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Card not found"
                End If
                Marshal.FreeHGlobal(addrPtr)
                MifareFree()
            Else
                OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Reader not found"
            End If
        Catch ex As Exception
            OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ex.Message
        End Try

    End Sub

    Private Sub pb_ReadSNR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_ReadSNR.Click

        Try
            If Not GetComInfo() = "" Then
                Dim ret As Integer = serialportInit(CInt(GetComInfo()))
                Dim addr As Byte() = New Byte(7) {}
                Dim addrPtr As IntPtr = Marshal.AllocHGlobal(addr.Length)
                ret = MifareGetSerNum(addrPtr)
                If (ret = 0) Then
                    Marshal.Copy(addrPtr, addr, 0, 8)
                    Dim addrstr As String = ""
                    For i As Integer = 0 To 7
                        Dim temp As String = addr(i).ToString("X")
                        If (temp.Length = 1) Then
                            temp = "0" & temp
                        End If
                        addrstr = addrstr & temp & " "
                    Next
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & " recieved data:"
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & addrstr
                Else
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Reader not found"

                End If
                Marshal.FreeHGlobal(addrPtr)
                MifareFree()
            Else
                OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Reader not found"
            End If
        Catch ex As Exception
            OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ex.Message
        End Try
    End Sub

    Private Sub pb_SetSNR_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pb_SetSNR.Click
        Try
            If Not GetComInfo() = "" Then
                Dim ret As Integer = serialportInit(CInt(GetComInfo()))
                Dim addrPtr As IntPtr = Marshal.AllocHGlobal(8)
                Dim offSet As Integer = 0
                Dim SNR As String = txtBox_SNR.Text
                SNR = SNR.Replace(" ", "")
                If SNR.Length = 16 Then
                    While SNR.Length > 0
                        Dim DB As Byte = System.Convert.ToByte(SNR.Substring(0, 2), 16)
                        Marshal.WriteByte(addrPtr, offSet, DB)
                        SNR = SNR.Substring(2, SNR.Length - 2)
                        offSet += 1
                    End While
                    ret = MifareSetSerNum(addrPtr)
                    If (ret = 0) Then
                        OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": SNR set successfully"
                    Else
                        OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Error in setting SNR"
                    End If
                Else
                    OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Please Re-Format the SNR"
                End If

                Marshal.FreeHGlobal(addrPtr)
                MifareFree()
            Else
                OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ": Reader not found"
            End If

        Catch ex As Exception
            OPTextBox.Text = OPTextBox.Text & vbNewLine & Now().ToString() & ex.Message
            MifareFree()
        End Try
    End Sub

    <DllImport("serialport.dll")> _
    Public Shared Function serialportInit(ByVal num As Integer) As Integer
    End Function

    <DllImport("serialport.dll")> _
    Public Shared Function MifareGetSerNum(ByVal addr As IntPtr) As Integer
    End Function

    <DllImport("serialport.dll")> _
    Public Shared Function MifareSetSerNum(ByVal addr As IntPtr) As Integer
    End Function


    <DllImport("serialport.dll")> _
    Public Shared Function MifareCheckCard(ByVal addr As IntPtr) As Integer
    End Function

    <DllImport("serialport.dll")> _
    Public Shared Sub MifareFree()
    End Sub

    <DllImport("serialport.dll")> _
    Public Shared Function MifareReadBlockData(ByVal addr As Byte, ByVal block As Byte, ByVal readData As IntPtr, ByVal len As UShort, ByVal key As IntPtr, ByVal uid As IntPtr, ByVal status As IntPtr) As Integer
    End Function

    'Public Declare Function MifareReadBlockData Lib "C:\WINDOWS\system32\serialport.dll" (ByVal addr As Byte, ByVal block As Byte, ByVal blockData As IntPtr, ByVal len As UShort, ByVal key As IntPtr) As Integer
    <DllImport("serialport.dll")> _
    Public Shared Function MifareWriteBlockData(ByVal addr As Byte, ByVal block As Byte, ByVal writeData As IntPtr, ByVal len As UShort, ByVal key As IntPtr, ByVal uid As IntPtr, ByVal status As IntPtr) As Integer
    End Function

    Public Enum DevStatus
        COMM_OK = &H0
        PARAM_OK = &H80
        COMM_ERR = &HFF
        SET_FAILED = &H81
        TIME_OUT = &H82
        NO_CARD = &H83
        RECEIVE_ERROR = &H84
        UNKNOWN_ERROR = &H87
        BAD_PARAM = &H85
        PASS_FAILED = &H8C
        BAD_COMMAND = &H8F
        ERROR_OUT_SECTOR = &HF0
    End Enum

End Class



'Cultureinfo.invatriantculture    "00"